﻿#pragma once

#include "SocketCommon.h"
#include "AutoPtr.h"

class CSession;
class CBuffer;

/**
@brief 패킷을 큐에 넣는 클래스.
*/
class CPacket
{
public:
	///생성자
	CPacket(const PACKET_EVENT& ePacketEvent, CSession* pcSession, CBuffer* pcBuffer = NULL);

	///소멸자
	~CPacket();

	///패킷 처리 메소드
	void Proc();

private:

	///패킷을 워커에 집어 넣는 메소드
	void _Push();

private:
	///CSession 포인터
	CSession* m_pcSession;

	const PACKET_EVENT m_ePacketEvent;

	///데이터 담을 버퍼
	ELKY::CAutoPtr<CBuffer> m_pcBuffer;
};