﻿#pragma once

#include "Common.h"

#include <stdio.h>
#include <string>

/**
@brief 디버그 정보를 출력하는 데에 사용하는 스트림
*/
class debugstream
{
public:
	/**
	@brief 생성자. 
	@param strServerName 서버 이름
	*/
	debugstream(const tstring& strServerName) : m_strProgramName(strServerName) 
	{
		
	}

	/**
	@brief 소멸자. 아무것도 안함.
	*/
    ~debugstream() 
	{ 
	}

	/**
	@brief 스택 정보 기록 시작시 부르는 메소드
	*/
	void Start()
	{
		m_strString.clear();
		m_strString += m_strProgramName;
		m_strString += _T(" ");
		m_strString += _T("\r\n");
	}

	/**
	@brief 스택 정보를 stl string에 기록
	*/
	void output_debug_string(const char *text)
	{
#ifdef _UNICODE
		int nWideLen;
		WCHAR szBuf[5120];
		nWideLen = MultiByteToWideChar(CP_ACP, 0, text, -1, NULL, 0); 
		MultiByteToWideChar(CP_ACP, 0, text, -1, szBuf, nWideLen); 
		m_strString += szBuf;
#else
		m_strString += text;
#endif
	}

	/**
	@brief 스택 정보기록을 끝낼 때 부르는 메소드
	*/
	void End()
	{
		m_strString += _T("\r\n");

		SYSTEMTIME st;
		GetLocalTime(&st);
		CLogWriter::GetInstancePtr()->Push(SLog(m_strProgramName, _T("StackWalker"),m_strString, st));
	}

private:
	///출력할 정보를 담은 stl string
	tstring m_strString;

	///서버 이름
	tstring m_strProgramName;
};

typedef debugstream dostream;

///dostream를 넘기고 스택을 추적하는 메소드
int exception_filter(dostream& os, EXCEPTION_POINTERS * pex);

///dostream를 넘기지 않고 스택 추적
int exception_filter(EXCEPTION_POINTERS * pex);